/****************************************************************************
** Form interface generated from reading ui file 'frmmain.ui'
**
** Created: Sun Sep 28 16:23:41 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef FRMMAIN_H
#define FRMMAIN_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <kiconloader.h>
#include <kpopupmenu.h>
#include <kmsystemtray.h>
#include <kmainwindow.h>
#include <qlistview.h>
#include <qhttp.h>
#include <ktabwidget.h>
#include <kprogress.h>
#include <qurloperator.h>
#include "qmmainwindow.h"
#include "playlist.h"
#include "player.h"
#include "frmtags.h"
#include "randtree.h"
#include "lyrics.h"
#include "frmlyrics.h"
#include "frmaudiocddevice.h"
#include "frmrestore.h"
#include "frmlfm.h"
#include "types.h"
#include "qfile.h"
#include "frmsoundsystem.h"
#include "frmplaylist.h"
#include "frmequalizer.h"
#include "frmremovabledevice.h"
#include "clickablelabel.h"
#include "qaction.h"
#include "frmaccels.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class KMListView;
class QMSlider;
class QMPushButton;
class QGroupBox;
class QButtonGroup;
class QSlider;
class ClickableLabel;
class KTabWidget;
class QWidget;
class QLineEdit;
class QLabel;

class frmMain : public QMMainWindow
{
    Q_OBJECT

public:
    frmMain( QWidget* parent = 0, const char* name = 0 );
    ~frmMain();

    QGroupBox* grpTrack;
    QMPushButton* pshGoToCurrent;
    QMPushButton* pshDown;
    QMPushButton* pshUp;
    QMPushButton* pshRemove;
    QButtonGroup* grpPlaylist;
    QMPushButton* pshNewPlaylist;
    QMPushButton* pshDeletePlaylist;
    QMPushButton* pshClearList;
    QMPushButton* pshLoop;
    QMPushButton* pshRnd;
    QGroupBox* grpControl;
    QMPushButton* pshLeft;
    QMPushButton* pshAction;
    QMPushButton* pshStop;
    QMPushButton* pshRight;
    QSlider* sldPos;
    ClickableLabel* lblTime;
    KTabWidget* tabPlaylist;
    QWidget* TabPage;
    KMListView* lstPlaylist;
    QLineEdit* txtSearch;
    QGroupBox* grpVolume;
    QLabel* pixVol;
    QMSlider* sldVol;

protected:

protected slots:
    virtual void languageChange();

    void resizeEvent(QResizeEvent * e);
    void hideEvent(QHideEvent * e);


private:
    QPixmap pixRndOff;
    QPixmap pixRndOn;
    QPixmap pixFollow;
    QPixmap pixStop;
    QPixmap pixPlay;
    QPixmap pixPause;
    QPixmap pixPlayOnce;
    QPixmap pixPlayLoop;
    QPixmap pixCopyOnPlaylist;
    QPixmap pixSendOnPlaylist;
    QPixmap pixAppendToPlaylist;
    QPixmap pixNewPlaylist;
    QPixmap pixTrackLoop;
    short int rnd;
    RandTree randList;
    frmTags dlgTags;
    int frame;
    short int loop;
    int playIndex;
    int playTab;
    int destTab;
    KMSystemTray * systemTray;
    KPopupMenu * popupMenu;
    QTimer playTimer;
    Player player;
    Playlist collection;
    QStatusBar * statBar;
    unsigned short int action;
    enum actionState{STOP, PLAY, PAUSE};
    QString currentTrack;
    QFile confFile;
    QFile tmpFiles;
    QFile currentTrackFile;
    KPopupMenu * contextMenu;
    QString homeDir;
    QString browseDir;
    QString filePattern;
    QFile lockFile;
    bool alreadyRunning;
    Lyrics lyrics;
    frmLyrics dlgLyrics;
    QTimer searchTimer;
    QHttp * http;
    QBuffer * buffer;
    QString lyricsErrStr;
    QString audioCDDevice;
    frmAudioCDDevice dlgAudioCDDevice;
    QPopupMenu * trackMenu;
    QPopupMenu * subMenuSend;
    QPopupMenu * subMenuCopy;
    QPopupMenu * subMenuAppend;
    QPopupMenu * subMenuSettings;
    QPopupMenu * subMenuRemove;
    QPopupMenu * playlistMenu;
    int desiredVolume;
    int lfmPercent;
    QTimer volumeTimer;
    QTimer tmpFilesTimer;
    QBuffer * lfmBuffer;
    QString * lfmChallenge;
    QString lfmPassword;
    QString lfmUser;
    QString * lfmAddr;
    frmLfm dlgLfm;
    bool lfmOn;
    QTimer lfmTimer;
    QPopupMenu * subMenuSort;
    QPopupMenu * subMenuSortOrder;
    QPopupMenu * subMenuSortOrderAscending;
    QPopupMenu * subMenuSortOrderDescending;
    QPopupMenu * stopMenu;
    QPopupMenu * headerMenu;
    bool stopAfter;
    lfmItemList queue;
    QHttp * lfmServer;
    QHttp * lfmSubmit;
    chks headerMenuItems;
    frmSoundSystem dlgSoundSystem;
    frmPlaylist dlgPlaylist;
    frmEqualizer dlgEqualizer;
    bool httpStream;
    QAction * actionQuit;
    QAction * actionSelectAll;
    QAction * actionCopyOnDest;
    QAction * actionSendOnDest;
    QAction * actionAppendToDest;
    QAction * actionMakeVolHigher;
    QAction * actionMakeVolLower;
    QAction * actionMakePrevCurrent;
    QAction * actionMakeNextCurrent;
    QAction * actionPopupCopyOnDest;
    QAction * actionPopupSendOnDest;
    QAction * actionPopupAppendTo;
    objsWithPos objsToMoveHor;
    objsWithPos objsToMoveVer;
    frmRestore dlgCopyFiles;
    QUrlOperator opCopyFiles;
    frmRemovableDevice dlgRemovableDevice;
    bool allowRefresh;
    bool playTimeDirection;
    frmAccels dlgAccels;

    QPixmap image0;

    void init();
    void destroy();
    void refreshPlaylist(const int & index);
    void refreshList();
    QString getTimeAsString(const int & time);
    exTags readTags(const QString & file);
    void writeTags(const QString & file, const QString & title, const QString & album, const QString & artist, const QString & year, const QString & comment, const QString & track, const QString & genre);
    QString browse(const QString & dir);
    int getRandom();
    void randMove(const int & current, const int & newCurrent);
    void onOff();
    void parse(const QString & data, bool ignoreM3u = false);
    void clearStop(bool remove = false);

private slots:
    void restore();
    void dragEnterEvent( QDragEnterEvent * event );
    void dropEvent( QDropEvent * event );
    void onNewPlaylist();
    void addPlaylist(bool = true);
    void setTabTip();
    void onDeletePlaylist();
    void onTabChanged();
    void onClearList();
    void onAction();
    void onVolume();
    void onPlayTimer();
    tags httpStreamMeta();
    void onSldPosPressed();
    void onSldPosReleased();
    void onSldPos(int);
    void onLeft();
    void onRight();
    void onPlaylist();
    void onUp();
    void onDown();
    void onRemove(bool ask = true);
    void onGoToCurrent();
    void onQuitSelected();
    void onAbout();
    void onLoop();
    void editTags();
    void setTip();
    void fileDropped( QDropEvent * event, QListViewItem * after );
    void scrollVol( QWheelEvent * e );
    void onMouseButtonReleased(const QPoint & p);
    void ensureVisible();
    void onStop();
    void store();
    void addFiles();
    void addFolders();
    void saveM3u();
    void openM3u(const QString & file);
    void onSldPosValChanged();
    void random();
    void onRnd();
    void lyricsDownloaded(bool e);
    void onDelLyrics();
    void onCodecChanged(int i);
    void onKeyPressed(QKeyEvent * e);
    void onSearchTimer();
    void onSearchTextChanged();
    void showContextMenu(const QPoint & p);
    void openAudioCD();
    bool copyOnPlaylist(int i);
    void sendOnPlaylist(int i);
    void copyOnDest();
    void sendOnDest();
    void appendToDest();
    void copyPlaylist();
    void appendPlaylist(int i);
    void restoreVolume();
    void makeUpPlaylist(int id);
    void lastFmHandShake();
    void lastFmResolved(bool e);
    void lastFmQueue();
    void lastFmSubmited(bool e);
    void editLfm();
    void markCurrent(int old = -1);
    void sortPlaylist(int type);
    void shufflePlaylist();
    void onStopPressed();
    void onShowStopMenu();
    void onStopMenu(int i);
    void onShowPlaylistHeaderMenu();
    void onPlaylistHeaderMenu();
    void setStatBarMsg();
    void addTmpFiles();
    void onSoundSystem();
    void onTestCanDecode(const QDragMoveEvent * e, bool & accept);
    void onReceivedDropEvent(QWidget * w, QDropEvent * e);
    void onInitiateDrag(QWidget * w);
    void onTabDblClicked(QWidget * w);
    void onEqualizer();
    void updateFreq(const int & amp, const int * freq);
    void onRemovableDevice();
    void removableDeviceFoundMountPoint(const unsigned long &, const unsigned long &, const unsigned long &, const QString &);
    void removableDeviceStartedNextCopy(const QPtrList<QNetworkOperation> &);
    void onSearch(bool begin = true);
    void onLyrics(bool force = false);
    void setPlayTimeMsg(bool reload = false);
    void onDragging();
    void onTimeClicked();
    void onAccels();
    void onMakePrevCurrent();
    void onMakeNextCurrent();
    void onPopupCopyOnDest();
    void onPopupSendOnDest();
    void onPopupAppendTo();
    void reloadTags();

};

#endif // FRMMAIN_H
